import { IDisposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { IBulkEditOptions, IBulkEditPreviewHandler, IBulkEditResult, ResourceEdit } from "@codingame/monaco-vscode-api/vscode/vs/editor/browser/services/bulkEditService";
import { IBulkEditService } from "@codingame/monaco-vscode-api/vscode/vs/editor/browser/services/bulkEditService.service";
import { WorkspaceEdit } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/languages";
import { IConfigurationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/configuration/common/configuration.service";
import { IDialogService } from "@codingame/monaco-vscode-api/vscode/vs/platform/dialogs/common/dialogs.service";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { ILogService } from "@codingame/monaco-vscode-api/vscode/vs/platform/log/common/log.service";
import { IEditorService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/editor/common/editorService.service";
import { ILifecycleService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/lifecycle/common/lifecycle.service";
import { IWorkingCopyService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/workingCopy/common/workingCopyService.service";
export declare class BulkEditService implements IBulkEditService {
    private readonly _instaService;
    private readonly _logService;
    private readonly _editorService;
    private readonly _lifecycleService;
    private readonly _dialogService;
    private readonly _workingCopyService;
    private readonly _configService;
    readonly _serviceBrand: undefined;
    private readonly _activeUndoRedoGroups;
    private _previewHandler?;
    constructor(_instaService: IInstantiationService, _logService: ILogService, _editorService: IEditorService, _lifecycleService: ILifecycleService, _dialogService: IDialogService, _workingCopyService: IWorkingCopyService, _configService: IConfigurationService);
    setPreviewHandler(handler: IBulkEditPreviewHandler): IDisposable;
    hasPreviewHandler(): boolean;
    apply(editsIn: ResourceEdit[] | WorkspaceEdit, options?: IBulkEditOptions): Promise<IBulkEditResult>;
    private _saveAll;
    private _shouldVeto;
}
