import { CancellationToken } from "@codingame/monaco-vscode-api/vscode/vs/base/common/cancellation";
import { URI } from "@codingame/monaco-vscode-api/vscode/vs/base/common/uri";
import { ResourceEdit } from "@codingame/monaco-vscode-api/vscode/vs/editor/browser/services/bulkEditService";
import { ICustomEdit, WorkspaceEditMetadata } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/languages";
import { IProgress } from "@codingame/monaco-vscode-api/vscode/vs/platform/progress/common/progress";
import { UndoRedoGroup, UndoRedoSource } from "@codingame/monaco-vscode-api/vscode/vs/platform/undoRedo/common/undoRedo";
import { IUndoRedoService } from "@codingame/monaco-vscode-api/vscode/vs/platform/undoRedo/common/undoRedo.service";
export declare class ResourceAttachmentEdit extends ResourceEdit implements ICustomEdit {
    readonly resource: URI;
    readonly undo: () => Promise<void> | void;
    readonly redo: () => Promise<void> | void;
    static is(candidate: any): candidate is ICustomEdit;
    static lift(edit: ICustomEdit): ResourceAttachmentEdit;
    constructor(resource: URI, undo: () => Promise<void> | void, redo: () => Promise<void> | void, metadata?: WorkspaceEditMetadata);
}
export declare class OpaqueEdits {
    private readonly _undoRedoGroup;
    private readonly _undoRedoSource;
    private readonly _progress;
    private readonly _token;
    private readonly _edits;
    private readonly _undoRedoService;
    constructor(_undoRedoGroup: UndoRedoGroup, _undoRedoSource: UndoRedoSource | undefined, _progress: IProgress<void>, _token: CancellationToken, _edits: ResourceAttachmentEdit[], _undoRedoService: IUndoRedoService);
    apply(): Promise<readonly URI[]>;
}
