import { CancellationToken } from "@codingame/monaco-vscode-api/vscode/vs/base/common/cancellation";
import { ResourceEdit } from "@codingame/monaco-vscode-api/vscode/vs/editor/browser/services/bulkEditService";
import { ITextModelService } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/services/resolverService.service";
import { IConfigurationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/configuration/common/configuration.service";
import { RawContextKey } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextkey/common/contextkey";
import { IContextKeyService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextkey/common/contextkey.service";
import { IContextMenuService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextview/browser/contextView.service";
import { IDialogService } from "@codingame/monaco-vscode-api/vscode/vs/platform/dialogs/common/dialogs.service";
import { IHoverService } from "@codingame/monaco-vscode-api/vscode/vs/platform/hover/browser/hover.service";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { IKeybindingService } from "@codingame/monaco-vscode-api/vscode/vs/platform/keybinding/common/keybinding.service";
import { ILabelService } from "@codingame/monaco-vscode-api/vscode/vs/platform/label/common/label.service";
import { IOpenerService } from "@codingame/monaco-vscode-api/vscode/vs/platform/opener/common/opener.service";
import { IStorageService } from "@codingame/monaco-vscode-api/vscode/vs/platform/storage/common/storage.service";
import { IThemeService } from "@codingame/monaco-vscode-api/vscode/vs/platform/theme/common/themeService.service";
import { ViewPane } from "@codingame/monaco-vscode-65619f8f-0eab-5d8b-855a-43b6353fe527-common/vscode/vs/workbench/browser/parts/views/viewPane";
import { IViewletViewOptions } from "@codingame/monaco-vscode-55ed5668-e8ca-5335-a587-790bcf1200c0-common/vscode/vs/workbench/browser/parts/views/viewsViewlet";
import { IViewDescriptorService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/common/views.service";
import { IEditorService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/editor/common/editorService.service";
export declare class BulkEditPane extends ViewPane {
    private readonly _instaService;
    private readonly _editorService;
    private readonly _labelService;
    private readonly _textModelService;
    private readonly _dialogService;
    private readonly _contextMenuService;
    private readonly _storageService;
    static readonly ID = "refactorPreview";
    static readonly Schema = "vscode-bulkeditpreview-multieditor";
    static readonly ctxHasCategories: RawContextKey<false>;
    static readonly ctxGroupByFile: RawContextKey<true>;
    static readonly ctxHasCheckedChanges: RawContextKey<true>;
    private static readonly _memGroupByFile;
    private _tree;
    private _treeDataSource;
    private _treeViewStates;
    private _message;
    private readonly _ctxHasCategories;
    private readonly _ctxGroupByFile;
    private readonly _ctxHasCheckedChanges;
    private readonly _disposables;
    private readonly _sessionDisposables;
    private _currentResolve?;
    private _currentInput?;
    private _currentProvider?;
    constructor(options: IViewletViewOptions, _instaService: IInstantiationService, _editorService: IEditorService, _labelService: ILabelService, _textModelService: ITextModelService, _dialogService: IDialogService, _contextMenuService: IContextMenuService, _storageService: IStorageService, contextKeyService: IContextKeyService, viewDescriptorService: IViewDescriptorService, keybindingService: IKeybindingService, contextMenuService: IContextMenuService, configurationService: IConfigurationService, openerService: IOpenerService, themeService: IThemeService, hoverService: IHoverService);
    dispose(): void;
    protected renderBody(parent: HTMLElement): void;
    protected layoutBody(height: number, width: number): void;
    private _setState;
    setInput(edit: ResourceEdit[], token: CancellationToken): Promise<ResourceEdit[] | undefined>;
    hasInput(): boolean;
    private _setTreeInput;
    accept(): void;
    discard(): void;
    private _done;
    toggleChecked(): void;
    groupByFile(): void;
    groupByType(): void;
    toggleGrouping(): void;
    private _openElementInMultiDiffEditor;
    private readonly _computeResourceDiffEditorInputs;
    private _onContextMenu;
}
